VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "howto_triangle_puzzle"
   ClientHeight    =   3090
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3090
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer tmrChangeSolution 
      Enabled         =   0   'False
      Interval        =   500
      Left            =   1680
      Top             =   360
   End
   Begin VB.CommandButton cmdShowAllSolutions 
      Caption         =   "Show All"
      Height          =   375
      Left            =   0
      TabIndex        =   1
      Top             =   480
      Width           =   1335
   End
   Begin VB.CommandButton cmdShowSolutions 
      Caption         =   "Show Solutions"
      Height          =   375
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   1335
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' The points.
Private Xs As Collection
Private Ys As Collection

' The solutions.
Private Solutions As Collection

' The solution we should display.
Private CurrentSolution As Integer

' Define the points and solutions.
Private Sub Form_Load()
Dim dy As Single
Dim dx As Single
Dim top_x As Single
Dim top_y As Single

    ScaleMode = vbPixels

    ' Define the points.
    dy = CSng(ScaleHeight / 4)
    dx = CSng(dy / Sqr(3))
    top_x = CSng(ScaleWidth / 2)
    top_y = -dy / 2
    Set Xs = New Collection
    Set Ys = New Collection
    Xs.Add (top_x - dx): Ys.Add (top_y + dy)
    Xs.Add (top_x + dx): Ys.Add (top_y + dy)
    Xs.Add (top_x - 2 * dx): Ys.Add (top_y + 2 * dy)
    Xs.Add (top_x - 0 * dx): Ys.Add (top_y + 2 * dy)
    Xs.Add (top_x + 2 * dx): Ys.Add (top_y + 2 * dy)
    Xs.Add (top_x - 3 * dx): Ys.Add (top_y + 3 * dy)
    Xs.Add (top_x - 1 * dx): Ys.Add (top_y + 3 * dy)
    Xs.Add (top_x + 1 * dx): Ys.Add (top_y + 3 * dy)
    Xs.Add (top_x + 3 * dx): Ys.Add (top_y + 3 * dy)
    Xs.Add (top_x - 2 * dx): Ys.Add (top_y + 4 * dy)
    Xs.Add (top_x - 0 * dx): Ys.Add (top_y + 4 * dy)
    Xs.Add (top_x + 2 * dx): Ys.Add (top_y + 4 * dy)

    ' Define the solutions.
    Set Solutions = New Collection

    ' Insert your code here...
    ' BASIC STRATEGY IS TO TRY ALL POSSIBLE SETS OF 3 POINTS AND CHECK IF THE
    ' THREE SIDE LENGTHS ARE THE SAME
    Dim lngIndex1 As Long  ' FOR POINT #1
    Dim lngIndex2 As Long  ' FOR POINT #2
    Dim lngIndex3 As Long  ' FOR POINT #3
    
    Dim lngEdgeA As Long   ' FOR EDGE #A, CONNECTS POINTS 1 AND 2
    Dim lngEdgeB As Long   ' FOR EDGE #B, CONNECTS POINTS 1 AND 3
    Dim lngEdgeC As Long   ' FOR EDGE #C, CONNECTS POINTS 2 AND 3
    
    Dim lngCounter As Long
    
    For lngIndex1 = 1 To Xs.Count - 2
      For lngIndex2 = lngIndex1 + 1 To Xs.Count - 1
        For lngIndex3 = lngIndex2 + 1 To Xs.Count
          
          ' EDGE LENGTHS EQUAL DISTANCE BETWEEN RESPECTIVE POINTS
          ' USING PYTHAGOREAN THEOREM:  Z = (dX^2 + dY^2)^(0.5)
          ' dX^2 = (X1 - X2)^2
          ' dY^2 = (Y1 - Y2)^2
          '
          ' I CONVERT TO LONGS HERE JUST TO AVOID ANY POTENTIAL ROUNDING ERROR THAT WOULD CAUSE
          ' THE EDGES TO BE NOT EXACTLY EQUAL
          '
          ' FOR THIS PUZZLE, WE DON'T ACTUALLY NEED THE TRUE LENGTH OF EACH EDGE.  WE COULD SOLVE
          ' THE PUZZLE A LITTLE QUICKER BY CHECKING IF THE SQUARES OF THE LENGTHS ARE EQUAL (I.E. BY
          ' SKIPPING THE STEP WHERE WE CALCULATE THE SQUARE ROOT OF EACH EDGE LENGTH), BUT I LEAVE
          ' THE FULL FORMULA HERE.
          lngEdgeA = CLng((((Xs(lngIndex1) - Xs(lngIndex2)) ^ 2) + ((Ys(lngIndex1) - Ys(lngIndex2)) ^ 2)) ^ (0.5))
          lngEdgeB = CLng((((Xs(lngIndex1) - Xs(lngIndex3)) ^ 2) + ((Ys(lngIndex1) - Ys(lngIndex3)) ^ 2)) ^ (0.5))
          lngEdgeC = CLng((((Xs(lngIndex2) - Xs(lngIndex3)) ^ 2) + ((Ys(lngIndex2) - Ys(lngIndex3)) ^ 2)) ^ (0.5))
          
          ' CHECK IF THREE EDGES ARE EQUAL
          If lngEdgeA = lngEdgeB And lngEdgeA = lngEdgeC Then
            AddSolution lngIndex1, lngIndex2, lngIndex3
            lngCounter = lngCounter + 1
            Debug.Print CStr(lngCounter) & "] Vertices " & CStr(lngIndex1) & ", " & CStr(lngIndex2) & _
                ", " & CStr(lngIndex3)
          End If
        Next lngIndex3
      Next lngIndex2
    Next lngIndex1
    
    
    ' Start displaying no solution.
    CurrentSolution = Solutions.Count + 1
End Sub

' Add a new solution.
Private Sub AddSolution(ParamArray indices() As Variant)
Dim new_solution As Collection
Dim i As Integer

    ' Create the new solution collection.
    Set new_solution = New Collection
    For i = LBound(indices) To UBound(indices)
        new_solution.Add indices(i)
    Next i
    
    ' Add the new solution to the solutions list.
    Solutions.Add new_solution
End Sub

' Draw the circles and any triangles currently defined.
Private Sub Form_Paint()
Const radius As Single = 5

Dim i As Integer

    ' Draw the points.
    Me.FillStyle = vbFSSolid
    Me.FillColor = vbBlue
    For i = 1 To Xs.Count
        Me.Circle (Xs(i), Ys(i)), radius, vbBlue
    Next i

    ' Draw the current solution.
    If (CurrentSolution < 1) Then
        ' Draw all solutions.
        For i = 1 To Solutions.Count
            DrawSolution i
        Next i
    Else
        ' Draw the current solution.
        DrawSolution CurrentSolution
    End If
End Sub

' Draw a solution.
Private Sub DrawSolution(ByVal solution_num As Integer)
Dim solution As Collection
Dim i As Integer

    If (solution_num > Solutions.Count) Then Exit Sub

    ' Draw this solution.
    Set solution = Solutions(solution_num)
    
    ' Start at the last point.
    Me.CurrentX = Xs(solution(solution.Count))
    Me.CurrentY = Ys(solution(solution.Count))
    
    ' Connect to the other points.
    For i = 1 To solution.Count
        Me.Line -(Xs(solution(i)), Ys(solution(i))), vbRed
    Next i
End Sub

' Start showing solutions.
Private Sub cmdShowSolutions_Click()
    ' Disable the button.
    cmdShowSolutions.Enabled = False

    ' Start at the first solution.
    CurrentSolution = 1

    ' Start the timer.
    tmrChangeSolution.Enabled = True

    ' Redraw.
    Refresh
End Sub

' Show the next solution.
Private Sub tmrChangeSolution_Timer()
    ' Increment CurrentSolution. If the result is greater than the
    ' last solution's index, disable the timer.
    CurrentSolution = CurrentSolution + 1
    tmrChangeSolution.Enabled = (CurrentSolution <= Solutions.Count)

    ' If we're done drawing, enable the button.
    cmdShowSolutions.Enabled = (Not tmrChangeSolution.Enabled)

    ' Redraw.
    Refresh
End Sub

' Show all of the solutions.
Private Sub cmdShowAllSolutions_Click()
    CurrentSolution = 0
    tmrChangeSolution.Enabled = False
    cmdShowSolutions.Enabled = True
    Refresh
End Sub
